      *
      * THIS IS USED FOR CONVERTING THE OFFICIAL EXPAT RELEASES TO ONES
      * USABLE ON THE ISERIES -- YOU DON'T NEED TO USE/RUN IT.
      *
     /*-                                                                            +
      * Copyright (c) 2004-2016 Scott C. Klement                                    +
      * All rights reserved.                                                        +
      *                                                                             +
      * Redistribution and use in source and binary forms, with or without          +
      * modification, are permitted provided that the following conditions          +
      * are met:                                                                    +
      * 1. Redistributions of source code must retain the above copyright           +
      *    notice, this list of conditions and the following disclaimer.            +
      * 2. Redistributions in binary form must reproduce the above copyright        +
      *    notice, this list of conditions and the following disclaimer in the      +
      *    documentation and/or other materials provided with the distribution.     +
      *                                                                             +
      * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND      +
      * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       +
      * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  +
      * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE     +
      * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  +
      * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS     +
      * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)       +
      * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT  +
      * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY   +
      * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF      +
      * SUCH DAMAGE.                                                                +
      */                                                                            +

      *
      *  This program is used by Scott to import Expat from it's
      *  gzipped/tar format into a source file/member format that's
      *  more familiar to iSeries people.
      *
      *  You do not need to use/run this program to use HTTPAPI
      *  or Expat -- it's for Scott's use only.
      *

     H DFTACTGRP(*NO)

     FSOURCE    UF A F  112        DISK    USROPN EXTFILE(SrcFile)
     F                                             EXTMBR(SrcMbr)

      /copy ifsio_h

     D EXVER           C                   '2.1.0'

     D CopyStmf        PR
     D   pePath                     256A   const varying
     D   peFile                     256A   const varying
     D   peSrcType                   10A   const varying
     D FixInclude      PR
     D   peSrcMbr                    10A   const
     D   peScan                     256A   varying dim(50)
     D   peNumScans                  10I 0 value
     D GetMbrName      PR            10A   varying
     D   peFile                     256A   const varying
     D MakeConfig      PR
     D   UTF16                        1N   const

     D QCMDEXC         PR                  ExtPgm('QCMDEXC')
     D   command                  32702A   const options(*varsize)
     D   length                      15P 5 const

     D UTF16           s              1N   inz(*ON)
     D Config          s             80A   dim(93) CTDATA

     D SrcFile         s             21A
     D SrcMbr          s             10A
     D name            s            256A   varying
     D dir             s               *
     D EXPATH          C                   '/home/sklement'
     D EXPKG           C                   'expat'
     D EXDIR           s            256A   varying
     D x               s             10I 0
     D y               s             10I 0
     D files           s            256A   varying dim(50)
     D ent             ds                  likeds(dirent)
     D                                     based(p_dirent)

     ISOURCE    NS
     I                                 13  112  SRCDTA

      /free
           EXDIR = EXPATH + '/' + EXPKG + '-' + EXVER;

           x = 1;
           files(x) = 'expat_config.h';
           MakeConfig(UTF16);

           dir = opendir(EXDIR + '/lib');
           p_dirent = readdir(dir);

           dow (p_dirent <> *NULL);
              name = %subst(ent.d_name: 1: ent.d_namelen);
              if (name<>'.' and name<>'..');
                 x = x + 1;
                 files(x) = name;
              endif;
              p_dirent = readdir(dir);
           enddo;

           closedir(dir);

           for y = 2 to x;
              CopyStmf(EXDIR + '/lib': files(y): 'C');
              FixInclude(GetMbrName(files(y)): files: x);
           endfor;

           FixInclude(GetMbrName(files(1)): files: x);

           CopyStmf(EXDIR + '/doc': 'reference.html': 'HTML');
           CopyStmf(EXDIR + '/doc': 'style.css'     : 'CSS');
           CopyStmf(EXDIR         : 'COPYING'       : 'TXT');

           return;

      /end-free

     OSOURCE    E            Update
     O                       SrcDta             112
     OSOURCE    EADD         Add
     O                       SrcDta             112

      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      * Copy the source from the Expat stream files to the EXPAT
      * source file in LIBEXPAT
      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     P CopyStmf        B
     D CopyStmf        PI
     D   pePath                     256A   const varying
     D   peFile                     256A   const varying
     D   peSrcType                   10A   const varying

     D wwMbr           s             10A   varying
     D cmd             s           1024A   varying

     D QMHSNDPM        PR                  ExtPgm('QMHSNDPM')
     D   MessageID                    7A   Const
     D   QualMsgF                    20A   Const
     D   MsgData                   1024A   Const options(*varsize)
     D   MsgDtaLen                   10I 0 Const
     D   MsgType                     10A   Const
     D   CallStkEnt                  10A   Const
     D   CallStkCnt                  10I 0 Const
     D   MessageKey                   4A
     D   ErrorCode                 1024A   options(*varsize)

     D key             s              4A
     D ErrorCode       s              8A   inz(x'0000000000000000')

      /free

          wwMbr = GetMbrName(peFile);

          cmd = 'CPYFRMSTMF FROMSTMF(''' + pePath + '/' + peFile + ''') ' +
                         '  TOMBR(''/qsys.lib/libexpat.lib/expat.file/' +
                                  wwMbr + '.mbr'') ' +
                         'DBFCCSID(37) ENDLINFMT(*LF) MBROPT(*REPLACE)';

          QMHSNDPM('CPF9897': 'QCPFMSG   *LIBL': cmd: %len(cmd): '*DIAG':
                   '*': 1: Key: ErrorCode);

          QCMDEXC(cmd: %len(cmd));

          cmd = 'CHGPFM FILE(LIBEXPAT/EXPAT) MBR(' + wwMbr + ') '
                 + 'SRCTYPE(' + peSrcType + ')';
          QCMDEXC(cmd: %len(cmd));

      /end-free
     P                 E


      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      * Copy the source from the Expat stream files to the EXPAT
      * source file in LIBEXPAT
      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     P MakeConfig      B
     D MakeConfig      PI
     D   UTF16                        1N   const
     D cmd             s           1024A   varying
     D x               s             10I 0
      /free
         SrcFile = 'LIBEXPAT/EXPAT';
         SrcMbr = 'EXPAT_CO.H';

         cmd = 'RMVM FILE(LIBEXPAT/EXPAT) MBR('+%trim(SrcMbr)+')';
         callp(e) QCMDEXC(cmd: %len(cmd));

         cmd = 'ADDPFM FILE(LIBEXPAT/EXPAT) MBR('+%trim(SrcMbr)+')'
             +       ' SRCTYPE(C)';
         QCMDEXC(cmd: %len(cmd));

         open Source;

         for x = 1 to %elem(Config);
            SrcDta = Config(x);

            select;
            when %scan('XML_UNICODE': SrcDta) > 0;
               if (UTF16);
                   SrcDta = '#define XML_UNICODE';
               else;
                   SrcDta = '/* #undef XML_UNICODE */';
               endif;
            when %scan('PACKAGE_NAME': SrcDta) > 0;
               SrcDta = '#define PACKAGE_NAME "' + EXPKG + '"';
            when %scan('PACKAGE_STRING': SrcDta) > 0;
               SrcDta = '#define PACKAGE_STRING "'
                      + EXPKG + ' ' + EXVER + '"';
            when %scan('PACKAGE_TARNAME': SrcDta) > 0;
               SrcDta = '#define PACKAGE_TARNAME "' + EXPKG + '"';
            when %scan('PACKAGE_VERSION': SrcDta) > 0;
               SrcDta = '#define PACKAGE_VERSION "' + EXVER + '"';
            endsl;

            except Add;
         endfor;

         close Source;

         SrcFile = 'LIBEXPAT/QRPGLESRC';
         SrcMbr  = 'EXPAT_H';

         open Source;
         read Source;

         dow not %eof(SOURCE);
             if %scan('define XML_UNICODE': SrcDta) > 0;
                if (UTF16);
                   SrcDta = '      /define XML_UNICODE';
                else;
                   SrcDta = '      /undefine XML_UNICODE';
                endif;
                except Update;
             endif;
             read Source;
         enddo;

         close Source;
      /end-free
     P                 E


      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      * Calculate a member name from a stream file name
      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     P GetMbrName      B
     D GetMbrName      PI            10A   varying
     D   peFile                     256A   const varying
     D dot             s             10I 0
     D wwMbr           s             20A   varying
     D wwExt           s              5A   varying
      /free

          dot = %scan('.': peFile);
          if (dot > 1);
             wwMbr = %subst(peFile: 1: dot-1);
             wwExt = %subst(peFile: dot);
          else;
             wwMbr = %trimr(peFile);
             wwExt = '';
          endif;

          if %len(wwMbr) > 8;
             wwMbr = %subst(wwMbr:1:8);
          endif;
          wwMbr = wwMbr + wwExt;

          if %len(wwMbr) > 10;
             wwMbr = %subst(wwMbr:1:10);
          endif;

          if peFile = 'reference.html';
             wwMbr = 'REF.HTML';
          endif;

          wwMbr = %xlate( 'abcdefghijklmnopqrstuvwxyz'
                        : 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
                        : wwMbr );
          return wwMbr;
      /end-free
     P                 E


      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      * Change #include statements to match the names that we changed
      *  the source members to.
      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     P FixInclude      B
     D FixInclude      PI
     D   peSrcMbr                    10A   const
     D   peScan                     256A   varying dim(50)
     D   peNumScans                  10I 0 value

     D wwMbr           s             10A   varying
     D x               s             10I 0

      /free

           SrcFile = 'LIBEXPAT/EXPAT';
           SrcMbr = peSrcMbr;

           open SOURCE;     // woowoo!
           read SOURCE;

           dow not %Eof(SOURCE);
              for x = 1 to peNumScans;
                 if SrcDta = '#include <' + peScan(x) + '>'
                       or SrcDta = '#include "' + peScan(x) + '"';
                    SrcDta = '#include <EXPAT/' +
                             GetMbrName(peScan(x)) + '>' ;
                    except UPDATE;
                 endif;
              endfor;
              read SOURCE;
           enddo;

           close SOURCE;  // nooooooooooooo!
      /end-free
     P                 E
**
/* 1234 = LIL_ENDIAN, 4321 = BIGENDIAN */
#define BYTEORDER 4321

/* Define to 1 if you have the `bcopy' function. */
/* #undef HAVE_BCOPY */

/* Define to 1 if you have the <dlfcn.h> header file. */
/* #undef HAVE_DLFCN_H */

/* Define to 1 if you have the <fcntl.h> header file. */
#define HAVE_FCNTL_H 1

/* Define to 1 if you have the `getpagesize' function. */
/* #undef HAVE_GETPAGESIZE */

/* Define to 1 if you have the <inttypes.h> header file. */
#define HAVE_INTTYPES_H 1

/* Define to 1 if you have the `memmove' function. */
#define HAVE_MEMMOVE 1

/* Define to 1 if you have the <memory.h> header file. */
#define HAVE_MEMORY_H 1

/* Define to 1 if you have a working `mmap' system call. */
#define HAVE_MMAP 1

/* Define to 1 if you have the <stdint.h> header file. */
/* #undef HAVE_STDINT_H */

/* Define to 1 if you have the <stdlib.h> header file. */
#define HAVE_STDLIB_H 1

/* Define to 1 if you have the <strings.h> header file. */
#define HAVE_STRINGS_H 1

/* Define to 1 if you have the <string.h> header file. */
#define HAVE_STRING_H 1

/* Define to 1 if you have the <sys/stat.h> header file. */
#define HAVE_SYS_STAT_H 1

/* Define to 1 if you have the <sys/types.h> header file. */
#define HAVE_SYS_TYPES_H 1

/* Define to 1 if you have the <unistd.h> header file. */
#define HAVE_UNISTD_H 1

/* Define to the address where bug reports for this package should be sent. */
#define PACKAGE_BUGREPORT "expat-bugs@mail.libexpat.org"

/* Define to the full name of this package. */
#define PACKAGE_NAME

/* Define to the full name and version of this package. */
#define PACKAGE_STRING

/* Define to the one symbol short name of this package. */
#define PACKAGE_TARNAME

/* Define to the version of this package. */
#define PACKAGE_VERSION

/* Define to 1 if you have the ANSI C header files. */
#define STDC_HEADERS 1

/* whether byteorder is bigendian */
#define WORDS_BIGENDIAN 1

/* Define to specify how much context to retain around the current parse
   point. */
#define XML_CONTEXT_BYTES 1024

/* Define to make parameter entity parsing functionality available. */
#define XML_DTD 1

/* Define to make XML Namespaces functionality available. */
#define XML_NS 1

/* Define to __FUNCTION__ or "" if `__func__' does not conform to ANSI C. */
/* #undef __func__ */

/* Define to empty if `const' does not conform to ANSI C. */
/* #undef const */

/* Define to `long' if <sys/types.h> does not define. */
/* #undef off_t */

/* Define to `unsigned' if <sys/types.h> does not define. */
/* #undef size_t */

/* Define to output UTF-16 instead of UTF-8 */
#define XML_UNICODE
